package com.gx.obe.bind.prop;

import java.util.Objects;
import java.util.function.BiPredicate;

import com.gx.obe.bind.base.P;
import com.gx.obe.bind.view.RView;
import com.gx.obe.bind.view.Read;
import com.gx.obe.bind.view.View;

public class RProp<T> extends P<T> {
	
	public void reader(Read<? extends T> read, View model) {
		Objects.requireNonNull(read);
		Objects.requireNonNull(model);
		
		model.addChangeListener(() -> change(read.get()));
	}
	
	public void reader(RView<? extends T> rView) {
		reader(rView, rView);
	}
	
	public RProp<T> as(String name) {
		super.as(name);
		return this;
	}
	
	public RProp<T> limit(BiPredicate<T, T> predicate) {
		super.limit(predicate);
		return this;
	}
	
}
